local TracerName, TracerData = ...

local WBLegionInfo = {};
local WBArgusInfo = {};
local LegionQuestsInfo = {};
TracerData.EQLegionInfo = {
	["Available"] = {
		["Alliance"] = 43341;
		["Horde"] = 43341;			
		},
	-- ["Quests"] = {
		-- 42170, --"Les Tisses Rêves",
		-- 42233, --"Tribus de Haut-Roc",
		-- 42234, --"Tornheim",			
		-- 42420, --"Azsuna",
		-- 42421, --"Suramar",
		-- 42422, --"Gardiennes",
		-- 43179, --"Le Kirin Thor de Dalaran",
		-- 48639, --"Armée de la Lumière",
		-- 48641, --"Armée du Déclin",
		-- 48642, --"Front arguséen",	
		-- },
	["Name"] = {},
	};


function TracerData.Function:WindowCreateLegion()
	--DB
	WBLegionInfo = {
		[42270] = {TracerData.L.WBLegion[107544], C_Map.GetMapInfo(634).name},	--"Nithogg - Torheim",
		[42269] = {TracerData.L.WBLegion[42269], C_Map.GetMapInfo(634).name},	--"Les faucheurs - Torheim",
		[42779] = {TracerData.L.WBLegion[108678], C_Map.GetMapInfo(641).name},	--"Shar'thos - Val'sharah",
		[43192] = {TracerData.L.WBLegion[108829], C_Map.GetMapInfo(630).name},	--"Levantus - Azsuna",
		[42819] = {TracerData.L.WBLegion[108879], C_Map.GetMapInfo(641).name},	--"Balmorgue - Val'sharah",
		[43193] = {TracerData.L.WBLegion[109331], C_Map.GetMapInfo(630).name},	--"Calamir - Azsuna",
		[43513] = {TracerData.L.WBLegion[110321], C_Map.GetMapInfo(680).name},	--"Na'zak le démon - Suramar",
		[43448] = {TracerData.L.WBLegion[110378], C_Map.GetMapInfo(650).name},	--"Drugon - Haut-Roc",
		[43512] = {TracerData.L.WBLegion[109943], C_Map.GetMapInfo(680).name},	--"Ana-Mouz - Suramar",
		[43985] = {TracerData.L.WBLegion[99929], C_Map.GetMapInfo(650).name},	--"Débris - Haut-Roc",
		[44287] = {TracerData.L.WBLegion[112350], C_Map.GetMapInfo(630).name},	--"J'im le Flétri - Azsuna",
	};
	WBArgusInfo = {
		[49166] = TracerData.L.WBArgus[124592],	--"Inquisiteur Méto",
		[49167] = TracerData.L.WBArgus[124625],	--"Alluradel",
		[49168] = TracerData.L.WBArgus[124719],	--"Seigneur des Abîmes Vilemus",
		[49169] = TracerData.L.WBArgus[124514],	--"Matrone Folnuna",
		[49170] = TracerData.L.WBArgus[124492],	--"Occularus",
		[49171] = TracerData.L.WBArgus[124555],	--"Sotanathor",
	};
	LegionQuestsInfo = {
		{questID = 48910, previous = 48441, item = 152095, name = TracerData.L.LegionQuests[48910]},
		{questID = 48911, previous = 48654, item = 152096, name = TracerData.L.LegionQuests[48911]},
		{questID = 48912, previous = 48448, item = 152097, name = TracerData.L.LegionQuests[48912]},
		{questID = 48799, previous = 48929, name = TracerData.L.LegionQuests[48799]},
		{questID = 47654, previous = 47220, name = TracerData.L.LegionQuests[47654]},
		{questID = 49293, previous = 48513, name = TracerData.L.LegionQuests[49293]},
	};
	TracerData.EQLegionInfo.Name = {
		[42170] = 1883, --"Les Tisses Rêves",
		[42233] = 1828, --"Tribus de Haut-Roc",
		[42234] = 1948, --"Tornheim",			
		[42420] = 1900, --"Azsuna",
		[42421] = 1859, --"Suramar",
		[42422] = 1894, --"Gardiennes",
		[43179] = 1090, --"Le Kirin Thor de Dalaran",
		[48639] = 2165, --"Armée de la Lumière",
		[48641] = 2045, --"Armée du Déclin",
		[48642] = 2170, --"Front arguséen",	
		};
		
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[3]
	TracerDB.ListLine[3] = {
		TracerData.L["Quêtes d'emmisaires"],
		"WB Legion",
		LegionQuestsInfo[1]["name"],
		LegionQuestsInfo[2]["name"],
		LegionQuestsInfo[3]["name"],
		LegionQuestsInfo[4]["name"],
		LegionQuestsInfo[5]["name"],
		LegionQuestsInfo[6]["name"],
		"WB Argus",	
		};
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(3, headername);

	--Affichage
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[3] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon
				if value == key1 then
					TracerData.Lines[3]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Quêtes d'emmisaires"
					if i == 1 then
						if value1["Quests"]["EQLegion"][1] == 3 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["EQLegion"][1] == 2 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
						elseif value1["Quests"]["EQLegion"][1] == 1 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareYellow");
						elseif value1["Quests"]["EQLegion"][1] == 0 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[3]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end						
					--"WB Legion"
					if i == 2 then
						TracerData.Lines[3][i]["Title"]:SetText("WB Legion : "..TracerDB.WBLegion);
						if value1["Quests"]["WBLegion"] == 0 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["WBLegion"] == 1 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[3]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end
					--
					if (i >= 3) and (i <= (#TracerDB.ListLine[3]-1))then
						local j = i-2;
						if value1.Quests.Argus[j] == 0 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1.Quests.Argus[j] == 1 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else					
							TracerData.Lines[3]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end
					--"WB Argus"
					if i == #TracerDB.ListLine[3] then
						TracerData.Lines[3][i]["Title"]:SetText("WB Argus : "..TracerDB.WBArgus);
						if value1["Quests"]["WBArgus"] == 0 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["WBArgus"] == 1 then
							TracerData.Lines[3]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[3]["Toon"..index][i]["Title"]:SetText("NA");
						end
					end						
				end
			end
		end
	end

	--Tooltip pour les quêtes d'émissaires
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[3]["Toon"..index][1]:SetScript("OnEnter", function()
			TracerData.Function:EQTooltip("Legion", value);
		end);
		TracerData.Lines[3]["Toon"..index][1]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end		
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end

	--Gestion Quêtes d'emissaires de Legion
	TracerData.Lines[3][1]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[3][1]:SetScript("OnEvent", function(_, event) 
		TracerData.Function:EmissaryQuestsChecking("Legion");	
	end)	
	
	--Gestion du WB de Legion
	TracerData.Lines[3][2]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[3][2]:RegisterEvent("PLAYER_ENTERING_WORLD");
	TracerData.Lines[3][2]:SetScript("OnEvent", function(_, event) 
		C_Timer.After(3, function() TracerData.Function:WorldBossCheckingLegion() end) 
	end)

	--Gestion des quêtes d'Argus
	TracerData.Lines[3][3]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[3][3]:RegisterEvent("PLAYER_ENTERING_WORLD");
	TracerData.Lines[3][3]:SetScript("OnEvent", function(_, event, arg1) 
		C_Timer.After(3, function() TracerData.Function:QuestsCheckingArgus() end) 
		end)	

	--Gestion du WB d'Argus
	TracerData.Lines[3][9]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[3][9]:RegisterEvent("PLAYER_ENTERING_WORLD");
	TracerData.Lines[3][9]:SetScript("OnEvent", function(_, event) 
		C_Timer.After(3, function() TracerData.Function:WorldBossCheckingArgus() end);
		end)	
end

function TracerData.Function:WorldBossCheckingLegion()
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 50 then return end
	
	for key, value in pairs(WBLegionInfo) do
		if	C_QuestLog.IsQuestFlaggedCompleted(key) then		
			TracerDB.WBLegion = value[1].." - "..value[2]; --Sauvegarde du nom du WeekBoss de la semaine
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][2]["Title"]:SetText(nil);
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
			TracerData.Lines[3][2]["Title"]:SetText("WB Legion : "..TracerDB.WBLegion);
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBLegion"] = 1;			
			break;
		else
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBLegion"] = 0;				
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][2]["Title"]:SetText(nil);
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
		end
	end
end

function TracerData.Function:QuestsCheckingArgus()
	for index, value in ipairs(LegionQuestsInfo) do
		if C_QuestLog.IsQuestFlaggedCompleted(value.previous) then
			if index < 4 then
				local numItem = TracerData.Function:GetContainerNumItem(value.item);
				if (numItem > 4) and (not C_QuestLog.IsQuestFlaggedCompleted(value.questID)) then
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareOrange");
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText(nil);
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = 0 ;			
				else
					if C_QuestLog.IsQuestFlaggedCompleted(value.questID) then
						TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText(nil);
						TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = 1 ;
					else
						TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText(nil);
						TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = 0 ;			
					end
				end				
			else
				if C_QuestLog.IsQuestFlaggedCompleted(value.questID) then
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText(nil);
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = 1 ;
				else
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
					TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText(nil);
					TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = 0 ;			
				end
			end
		else
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Title"]:SetText("NA");
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][index+2]["Texture2"]:SetTexture(nil);
			TracerDB.Toons[TracerData.thisToon]["Quests"]["Argus"][index] = -1 ;
		end
	end	
end

function TracerData.Function:WorldBossCheckingArgus()
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 50 then return end
	
	for key, value in pairs(WBArgusInfo) do
		if	C_QuestLog.IsQuestFlaggedCompleted(key) then		
			TracerDB.WBLegion = value --Sauvegarde du nom du WeekBoss de la semaine
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][9]["Title"]:SetText(nil);
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][9]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
			TracerData.Lines[3][9]["Title"]:SetText("WB Argus : "..TracerDB.WBArgus);
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBArgus"] = 1;			
			break;
		else
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBArgus"] = 0;				
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][9]["Title"]:SetText(nil);
			TracerData.Lines[3]["Toon"..TracerData.numthisToon][9]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
		end
	end
end
