local TracerName, TracerData = ...
local flag = false;

function TracerData.Function:WindowCreateLoveIsInTheAir()
	TracerDB.ListLine[12] = {};
	
	--Détection de l'évènement
	local Date = date("*t");
	if Date.month == 2 then
		if (Date.day >= 6) and (Date.day <= 20) then
			flag = true;
		end
	end
	--Arrêt de la fonction s'il n'y a pas d'évènement
	if not flag then 
		return
	else
		--DB
		
		--Informations pour la création de la catégorie
		local headername = TracerData.L.Headers[12];
		TracerDB.ListLine[12] = {
			TracerData.L["Donjon journalier"],
			TracerData.L["Quêtes journalières"],
			};
			
		--Création de la catégorie
		TracerData.Function:WindowCreate(12, headername);
	
		--Affichage
		TracerData.Function:WindowUpdateLoveIsInTheAir();

		if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
		
		TracerData.Lines[12][1]:RegisterEvent("LFG_COMPLETION_REWARD");
		TracerData.Lines[12][1]:RegisterEvent("LFG_LOCK_INFO_RECEIVED");		
		TracerData.Lines[12][1]:SetScript("OnEvent", function(_, event) 
			if event == "LFG_COMPLETION_REWARD" then
				RequestLFDPlayerLockInfo();
			else
				TracerData.Function:LoveIsInTheAirDungeonChecking();
			end
		end)
		
		--Premier checking
		TracerData.Function:LoveIsInTheAirDungeonChecking();
	end
	
	flag = false;
end

function TracerData.Function:WindowUpdateLoveIsInTheAir()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[12] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[12]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Donjon quotidien"
					if i == 1 then
						if value1.Level < 50 then
							TracerData.Lines[12]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[12]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						else
							TracerData.Lines[12]["Toon"..index][i]["Title"]:SetText(nil);
							if value1["LoveIsInTheAir"][1] == 0 then
								TracerData.Lines[12]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							elseif value1["LoveIsInTheAir"][1] == 1 then
								TracerData.Lines[12]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							end
						end
					end
					--"Journalière"
					if i == 2 then
						if value1["LoveIsInTheAir"][2] == 3 then
							TracerData.Lines[12]["Toon"..index][i]["Title"]:SetText("NA");	
							TracerData.Lines[12]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[12]["Toon"..index][i]["Texture2"]:SetTexture(nil);
							TracerData.Lines[12]["Toon"..index][i]["Title"]:SetText(value1["LoveIsInTheAir"][2].."/3");
						end
					end	
				end
			end
		end
	end	
end

function TracerData.Function:LoveIsInTheAirDungeonChecking()
	local doneToday, moneyAmount, moneyVar, experienceGained, experienceVar, numRewards, spellID = GetLFGDungeonRewards(288);
	if doneToday then
		TracerDB["Toons"][TracerData.thisToon]["LoveIsInTheAir"][1] = 1;		
	else
		TracerDB["Toons"][TracerData.thisToon]["LoveIsInTheAir"][1] = 0;
	end
	
	--Affichage
	TracerData.Function:WindowUpdateLoveIsInTheAir();
end
