local TracerName, TracerData = ...

local CurrentWorldEvent = 0;
local CurrentWorldEventDungeonId = 0;

function TracerData.Function:WindowCreateWorldEvent1()
	TracerDB.ListLine[12] = {};
	
	--Détection de l'évènement
	local Date = date("*t");
	TracerDB.test = Date;
	--De l'Amour dans l'air (1)
	if Date.month == 2 then
		if (Date.day >= 7) and (Date.day <= 21) then
			CurrentWorldEvent == 1;
			CurrentWorldEventDungeonId = 288;
		end
	end
	--Arrêt de la fonction s'il n'y a pas d'évènement
	if CurrentWorldEvent == 0 then 
		return
	else
		if CurrentWorldEvent == 1 then
			TracerDB.ListLine[12] = {
				TracerData.L["De l'Amour dans l'air"],
				};		
		end
		TracerData.Function:WindowCreateWorldEvent2();	
	end
end

function TracerData.Function:WindowCreateWorldEvent2()
	--DB
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[12];
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(12, headername);
	
	--Affichage
	TracerData.Function:WindowUpdateWorldEvent();

	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	if CurrentWorldEvent == 1 then
		TracerData.Headers[12]:SetText(TracerData.L["WE : De l'Amour dans l'air"]);
		TracerData.Lines[12][1]:RegisterEvent("LFG_COMPLETION_REWARD");
		TracerData.Lines[12][1]:SetScript("OnEvent", function(_, event) 
			RequestLFDPlayerLockInfo();
			C_Timer.After(5, function() TracerData.Function:WorldEventDungeonChecking(); end);
		end)
	end
end

function TracerData.Function:WindowUpdateWorldEvent()
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[12] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[headernum]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					
				end
			end
		end
	end	
end

function TracerData.Function:WorldEventDungeonChecking()
	if CurrentWorldEvent == 1 then
		local doneToday = GetLFGDungeonRewards(CurrentWorldEventDungeonId)
		if doneToday then
			TracerDB["Toons"][TracerData.thisToon]["LoveIsInTheAir"] = 1;		
		else
			TracerDB["Toons"][TracerData.thisToon]["LoveIsInTheAir"] = 0;
		end
	end
	
	--Affichage
	TracerData.Function:WindowUpdateWorldEvent();
end
