local TracerName, TracerData = ...

-- ----------------------------------------------------------------------------------------------------------
-- ----------------- Localisation ---------------------------------------------------------------------------
-- ----------------------------------------------------------------------------------------------------------

TracerData.Lfrench = {
	["Headers"] = {
		"Informations générales",	
		"Battle for Azeroth",		
		"Legion",		
		"Monnaies",		
		"Réputations (en %)",		
		"Vérouillages d'instances",		
		"Évènement hebdomadaire",		
		"Foire de Sombrelune",			
		"Shadowlands",
		"PVP",
		"",
		"L'amour est dans l'air",
		"Dragonflight",
		},
	["Pseudo"] = "Pseudo",
	["Ilvl"] = "Ilvl",
	["Donjon héro du jour"] = "Donjon héro du jour",
	["Donjon Mythique"] = "Donjons mythique",
	["La chambre-forte"] = "La chambre-forte",
	["Clé disponible"] = "Clé disponible",
	["Bataille Stromgarde"] = "Arathi",
	["Bataille Sombrivage"] = "Sombrivage",
	["Contibution"] = "Contribution",
	["Siège"] = "Siège",
	["Patrouille"] = "Patrouille",
	["Quêtes d'emmisaires"] = "Quêtes d'emmisaires",
	["Exploration d'îles"] = "Exploration d'îles",
	["Coeur d'Azeroth"] = "Coeur d'Azeroth",
	["WB BfA"] = "WB BfA",
	["WB Nzoth"] = "WB N'zoth",		
	["Quêtes BfA"] = "Quêtes BfA",
	["WBBfA"] = {
		[140252] = 	"Assemblage",	--Assemblage - Drustvar
		[132701] = 	"T'zane",		--T'zane - Nazmir
		[132253] = 	"Ji'arak",		--Ji'arak - Zuldazar
		[136385] = 	"Azuréthos",	--Azuréthos - Mer de Kul Tiras
		[140163] =  "Yenajz",		--Yenajz - Vallée Chantorage
		[138794] = 	"Kraulok",		--Krolauk - Vol'dun	
		},
	["WBNaz"] = {
		[56057] = "Le lieur d'âme",
		[56056] = "Wekemara",		
		},
	["WBNzoth"] = {
		[154638] = "Shek'zara",
		[160970] = "Vuk'laz",		
		},		
	["WBLegion"] = {
		[107544] = 	"Nithogg",			--"Nithogg - Torheim",
		[42269] = 	"Les faucheurs",	--"Les faucheurs - Torheim",
		[108678] = 	"Shar'thos",		--"Shar'thos - Val'sharah",
		[108829] = 	"Levantus",			--"Levantus - Azsuna",
		[108879] = 	"Balmorgue",		--"Balmorgue - Val'sharah",
		[109331] = 	"Calamir",			--"Calamir - Azsuna",
		[110321] = 	"Na'zak",			--"Na'zak le démon - Suramar",
		[110378] = 	"Drugon",			--"Drugon - Haut-Roc",
		[109943] = 	"Ana-Mouz",			--"Ana-Mouz - Suramar",
		[99929] = 	"Débris",			--"Débris - Haut-Roc",
		[112350] = 	"J'im le Flétri",	--"J'im le Flétri - Azsuna",	
		},
	["WBArgus"] = {
		[124592] = "Inquisiteur Méto",
		[124625] = "Alluradel",
		[124719] = "Vilemus",
		[124514] = "Matrone Folnuna",
		[124492] = "Occularus",
		[124555] = "Sotanathor",
		},
	["WBSL"] = {
		[173104] = "Mortanis",		--Mortanis - Maldraxxus
		[167527] = "Oranomonos",	--Oranomonos - Sylvarden
		[167526] = "Nurgash",		--Nurgash - Revendredth		
		[167524] = "Valinor",		--Valinor - Bastion		
		},
	["WBDF"] = {
		[193532] = "Bazual",		--Bazual - Travée d'Azur	
		[193533] = "Liskanoth",		--Liskanoth - Thaldraszus	
		[193534] = "Strunraan",		--Strunraan  - Plaines d'Ohn'arha
		[193535] = "Basrikron ",	--Basrikron  - Rivages de l'Éveil		
		},		
	["LegionQuests"] = {
		[48910] = "Fournir Krokuun",
		[48911] = "Inoculation du Vide",
		[48912] = "Fournir la campagne antoréenne",
		[48799] = "L'énergie d'un monde condamné",
		[47654] = "Le cimier de la connaissance",
		[49293] = "Assaut du site d'invasion",	
		},	
	["RG"] = "RG",
	["Perles"] = "Perles",
	["PO"] = "PO",
	["Tracer : Evènement Timewalking en cours"]	= "Tracer : Evènement Timewalking en cours",
	["Passage dans les limbes"] = "Passage dans les limbes",
	["Quête du 1er donjon"] = "Quête du 1er donjon",
	["Quête Raid"] = "Quête Raid",	
	["Évènement Bonus Expéditions"] = "Évènement Hebdo (Expéditions)",
	["Quête hebdo"] = "Quête hebdo";
	["Évènement Bonus Champs de Bataille"] = "Évènement Hebdo (Champs de bataille)",
	["Évènement Bonus Donjons DF"] = "Évènement Hebdo (Donjons DF)",
	["Évènement Bonus Mascottes"] = "Évènement Hebdo (Mascottes)",
	["Évènement Bonus Arène"] = "Évènement Hebdo (Arène)",
	["Foire de Sombrelune disponible"] = "Foire de Sombrelune disponible",
	["Quêtes journalières"] = "Quêtes journalières",
	["Quêtes de métiers"] = "Quêtes de métiers",
	["Quêtes Artéfacts ou Boss"] = "Quêtes Artéfacts ou Boss",
	["Darkmoon"] = {
		["Daily"] = {
			[29436] = "Le boulet de canon humanoïde",
			[29463] = "Il est temps de cogner",	
			[29438] = "Il tire et... il marque",
			[36481] = "Défi de l'Oiseau de feu",
			[29434] = "Commandant de chariotte",
			[29455] = "Cible : Tortue",
			[37910] = "La course folle",
			[37911] = "La grande course folle",
			[32175] = "Combat de mascotte de Sombrelune",			
			[36471] = "Un nouvel adversaire à Sombrelune",
			},
		["Items"] = {
			[29433] = "Testez votre force",
			[33354] = "Croc-de-Lune (Boss)",
			[29443] = "Un étrange cristal",
			[29444] = "Un oeuf exotique",
			[29445] = "Un grimoire fascinant",
			[29446] = "Une arme extraordinaire",
			[29464] = "Outils de divination",
			[29451] = "Le maître stratège",
			[29458] = "Journal d'aventurier défunt (JcJ)",
			[29456] = "Une bannière capturée (JcJ)",
			[29457] = "L'insigne de l'ennemi (JcJ)",		
			},
		},	
	["|cff00ff00Les Daily ont été réinitialisées|r"] = "|cff00ff00Les Daily ont été réinitialisées|r",
	["|cffff0000Les Weekly ont été réinitialisées|r"] = "|cffff0000Les Weekly ont été réinitialisées|r",
	["|cfa913f00Les Bi-Weekly ont été réinitialisées|r"] = "|cfa913f00Les Bi-Weekly ont été réinitialisées|r",
	["Resize"] = "Calibrer",
	["Options"] = {
		["Options"] = "Options",
		["Affichage"] = "Affichage",		
		["Persos"] = "Persos",
		["Warfronts"] = "Warfronts",
		["Infos"] = "Infos",			--need
		["Sélection"] = "Sélection",
		["Sélection des lignes"] = "Lignes à afficher",	
		["Catégories"] = "Catégories",
		["Largeur de la 1ere colonne"] = "Largeur de la 1ere colonne",
		["Largeur par personnages"] = "Largeur par personnage",
		["Hauteur des lignes"] = "Hauteur des lignes",
		["Reset de la position de la fenêtre"] = "Reset de la position de la fenêtre",
		["Afficher à la connexion"] = "Afficher à la connexion",
		["Reset de la base de données"] = "Reset de la base de données",
		["Sélection des personnages"] = "Sélection des personnages",	
		["Ordre de l'affichage"] = "Ordre d'affichage des personnages",
		["Pseudo plus court"] = "Pseudo plus court",
		["Supprimer un personnage"] = "Supprimer un personnage",
		["Serveurs"] = "Serveurs",
		["Actualiser"] = "Sauvegarder",
		["Annuler"] = "Annuler",
		["Fermer"] = "Fermer",
		["Icône sur la minimap"] = "Icône sur la minimap",
		},
	["Terminé"] = "|cff00ff00Terminé|r",
	["Inconnu"] = "|cffff0000Inconnu|r",
	["jour"] = "jour",
	["jours"] = "jours",	
	["Clé"] = "Clé",
	["Coffre"] = "Coffre",
	["Cœur d'Azeroth"] = "Cœur d'Azeroth",
	["Niveau"] = "Niveau",
	["Prochain niveau"]	= "Prochain niveau",
	["j"] = "j",
	["Nazjatar daily"] = "Nazjatar journa",
	["Nazjatar weekly"] = "Nazjatar hebdo (Mardivas + WB)",
	["Parangon"] = "Parangon",	
	["Personnalisé"] = "Personnalisé",
	["Afficher les informations relatives \nà votre sélection \npar le menu options"] = "Afficher les informations relatives \nà votre sélection par le menu options",
	["Afficher les informations \nrelatives à BfA uniquement"] = "Afficher les informations \nrelatives à BfA uniquement",
	["Afficher les informations \nrelatives à Legion uniquement"] = "Afficher les informations \nrelatives à Legion uniquement",	
	["Afficher les informations \nrelatives à WoD uniquement"] = "Afficher les informations \nrelatives à WoD uniquement",
	["Afficher les informations \nrelatives à SL uniquement"] = "Afficher les informations \nrelatives à SL uniquement",
	["Afficher les informations \nrelatives à DF uniquement"] = "Afficher les informations \nrelatives à DF uniquement",
	["Montures"] = "Montures",
	["Jouets"] = "Jouets",
	["Mascottes"] = "Mascottes",
	["Mechagon"] = "Mécagone journa",
	["Mechagon daily"] = "Expédition journalière (850 pts)",
	["Mechagon recycling"] = "Quête de recyclage (150 pts)",
	["Mechagon WM"] = "Quête WM (200 pts)",
	["BFAQuests"] = {
		"Campagne de guerre",
		"Vol Draconique Noir",
		"Vol Draconique Vert",
		"Vol Draconique Rouge",
		"Vol Draconique Bleu",
		"Hyjal",
		"Malström",
		"Expeditions Nazjatar",
		"Ashjra'kamas",
		},
	["Assaults"] = "Assaults de N'Zoth",		
	["Val"] = "Val de l’Éternel printemps",
	["MiniVision"] = "Mini-Vision de N'Zoth",	
	["Point de Conquête (Cap)"] = "Point de Conquête (500)",
	["Journalières"] = "Journalières",		
	["Journalières Côté"] = "Journalières Côtées",		
	["Quêtes d'Appel aux armes"] = "Quêtes d'Appel aux armes",	
	["Bataille de Nazjatar"] = "Bataille de Nazjatar",	
	["Champ de Bataille"] = "Champ de Bataille",
	["Champ de Bataille Épique"] = "Champ de Bataille Épique",	
	["Escarmouche"]	= "Escarmouche",
	["Arène 2v2"] = "Arène 2v2",
	["Arène 3v3"] = "Arène 3v3",	
	["Champ de Bataille Côté"] = "Champ de Bataille Côté",
	["TracerLimit"] = "Tracer : Attention !! L'addon peut gérer un maximum de "..TracerData.CharactersLimit.." personnages. Utilisez le menu Options de l'addon pour effacer des personnages",	
	["Congrégation"] = "Congrégation",
	["CongrégationName"] = {
		"Kyrian",
		"Venthyr",
		"Faë Nocturne",
		"Nécro-Seigneurs",
		},
	["Appels"] = "Appels",
	["Donjons de la semaine"] = "Donjons de la semaine",
	["Échelon"] = "Échelon",
	["Quêtes de donjon de la semaine"] = "Quêtes de donjon de la semaine",
	["Appels"] = "Appels",
	["Quête inconnue"] = "Quête inconnue",
	["CF"] = "Chambre Forte",
	["Weekly Anima"] = "Quête Anima",
	["Quêtes de Bolvar"] = "Quêtes de Bolvar",
	["Ailes complétées"] = "Ailes complétées",
	["Assaults SL"] = "Assaut de congrégation",
	["Liste des mm+ fait cette semaine"] = "Liste des mm+ fait cette semaine",
	["Ilvl des récompenses du coffre"] = "Ilvl des récompenses du coffre",
	["Coffre"] = "Coffre",
	["Donjon journalier"] = "Donjon journalier",
	["Renom"] = "Renom";
	["Camp Aylaag"] = "Camp Aylaag";
	["WQ Course draconique"] = "WQ Courses draconique",
	["WQ Irion ou Sabellian"] = "WQ Irion ou Sabellian",
	["Coffres hebdo"] = "Coffres hebdo",
	["WeeklyChestsName"] = {
		[71033] = "Épreuve de l'eau (Ohn'ahra)",			--Trial of Water (Ohn'ahra)
		[71995] = "Épreuve des éléments (Chromie)",			--Trial of Elements (Chromie)
		[70906] = "Grande chasse",							--Chasse Maruuk
		[70893] = "Festin rohart",							--Festin rohart
		[70866] = "Siège du donjon du Fléau-des-Dragons",	--Siège du donjon du Fléau-des-Dragons
		[74378] = "La fureur de l'orage",				--Fureur de l'orage			
		},
	["Métiers : Connaissances"] = "Métiers : Connaissances",
	["Points de connaissance de métier"] = "Points de connaissance de métier",	
};

TracerData.Lenglish = {
	["Headers"] = {
		"General Informations",	
		"Battle for Azeroth",		
		"Legion",		
		"Currencies",		
		"Reputation (in %)",		
		"Raids Lockout",		
		"Weekly event",		
		"Darkmoon Faire",		
		"Shadowlands",
		"PVP",		
		"",
		"Love is in the air",
		"Dragonflight",
		},
	["Pseudo"] = "Character",
	["Ilvl"] = "Ilvl",
	["Donjon héro du jour"] = "Daily hero dungeon",
	["Donjon Mythique"] = "Mythic dungeons",
	["La chambre-forte"] = "The Great Vault",
	["Clé disponible"] = "Mythic key",
	["Bataille Stromgarde"] = "Arathi",
	["Bataille Sombrivage"] = "Darkshore",
	["Contibution"] = "Contribution",
	["Siège"] = "Siege",
	["Patrouille"] = "Patrol",
	["Quêtes d'emmisaires"] = "Emissary Quests",
	["Coeur d'Azeroth"] = "Heart of Azeroth",	
	["Exploration d'îles"] = "Island expeditions",
	["WB BfA"] = "WB BfA",
	["WB Nzoth"] = "WB N'zoth",	
	["Quêtes BfA"] = "Quests BfA",
	["WBBfA"] = {
		[140252] = 	"Hailstone",	--Assemblage - Drustvar
		[132701] = 	"T'zane",		--T'zane - Nazmir
		[132253] = 	"Ji'arak",		--Ji'arak - Zuldazar
		[136385] = 	"Azurethos",	--Azuréthos - Mer de Kul Tiras
		[140163] =  "Yenajz",		--Yenajz - Vallée Chantorage
		[138794] = 	"Kraulok",		--Krolauk - Vol'dun	
		},
	["WBNaz"] = {
		[56057] = "The Soulbinder",
		[56056] = "Wekemara",
		},	
	["WBNzoth"] = {
		[154638] = "Shek'zara",
		[160970] = "Vuk'laz",		
		},
	["WBLegion"] = {
		[107544] = 	"Nithogg",			--"Nithogg - Torheim",
		[42269] = 	"The Soultakers",	--"Les faucheurs - Torheim",
		[108678] = 	"Shar'thos",		--"Shar'thos - Val'sharah",
		[108829] = 	"Levantus",			--"Levantus - Azsuna",
		[108879] = 	"Humongris",		--"Balmorgue - Val'sharah",
		[109331] = 	"Calamir",			--"Calamir - Azsuna",
		[110321] = 	"Na'zak",			--"Na'zak le démon - Suramar",
		[110378] = 	"Drugon",			--"Drugon - Haut-Roc",
		[109943] = 	"Ana-Mouz",			--"Ana-Mouz - Suramar",
		[99929] = 	"Flotsam",			--"Débris - Haut-Roc",
		[112350] = 	"Withered J'im",	--"J'im le Flétri - Azsuna",	
		},
	["WBArgus"] = {
		[124592] = "Inquisitor Méto",
		[124625] = "Mistress Alluradel",
		[124719] = "Pit Lord Vilemus",
		[124514] = "Matron Folnuna",
		[124492] = "Occularus",
		[124555] = "Sotanathor",
		},	
	["WBSL"] = {
		[173104] = "Mortanis",		--Mortanis - Maldraxxus
		[167527] = "Oranomonos",	--Oranomonos - Sylvarden
		[167526] = "Nurgash",		--Nurgash - Revendredth	
		[167524] = "Valinor",		--Valinor - Bastion			
		},
	["WBDF"] = {
		[193532] = "Bazual",		--Bazual - Travée d'Azur
		[193533] = "Liskanoth",		--Liskanoth - Thaldraszus		
		[193534] = "Strunraan",		--Strunraan  - Plaines d'Ohn'arha		
		[193535] = "Basrikron",		--Basrikron  - Rivages de l'Éveil
		},		
	["LegionQuests"] = {
		[48910] = "Supplying Krokuun",
		[48911] = "Void Inoculation",
		[48912] = "Supplying the Antoran Campaign",
		[48799] = "Fuel of a Doomed World",
		[47654] = "The Crest of Knowledge",
		[49293] = "Invasion Onslaught",	
		},
	["RG"] = "WR",
	["Perles"] = "Pearls",	
	["PO"] = "Gold",	
	["Tracer : Evènement Timewalking en cours"]	= "Tracer : Timewalking dungeons available",	
	["Passage dans les limbes"] = "A path through time",
	["Quête du 1er donjon"] = "First dungeon quest",
	["Quête Raid"] = "Raid Quest",
	["Évènement Bonus Expéditions"] = "Weekly event (Emissary quests)",
	["Quête hebdo"] = "Weekly quest";
	["Évènement Bonus Champs de Bataille"] = "Weekly event (Battleground)",
	["Évènement Bonus Donjons DF"] = "Weekly event (DF dungeons)",
	["Évènement Bonus Mascottes"] = "Weekly event (Pet battle)",
	["Évènement Bonus Arène"] = "Weekly event (Arena)",
	["Foire de Sombrelune disponible"] = "Darkmoon Faire available",
	["Quêtes journalières"] = "Daily Quests",
	["Quêtes de métiers"] = "Professions quests",
	["Quêtes Artéfacts ou Boss"] = "Artefacts or Boss quests",
	["Darkmoon"] = {
		["Daily"] = {
			[29436] = "The humanoid cannonball",
			[29463] = "It's hammer time",	
			[29438] = "He shoots, he scores !",
			[36481] = "Firebird's challenge",
			[29434] = "Tonk commander",
			[29455] = "Target : Turtle",
			[37910] = "The real race",
			[37911] = "The real big race",
			[32175] = "Darkmoon pet battle !",			
			[36471] = "A new darkmoon challenger !",
			},
		["Items"] = {
			[29433] = "Test your strength",
			[33354] = "Den mother's demise",
			[29443] = "A curious crystal",
			[29444] = "An exotic egg",
			[29445] = "An intriguing grimoire",
			[29446] = "A wondrous weapon",
			[29464] = "Tools of divination",
			[29451] = "The master strategist",
			[29458] = "The captured journal (PvP)",
			[29456] = "A captured banner (PvP)",
			[29457] = "The enemy's insignia (PvP)",		
			},
		},
	["Évènement saisonnier"] = "World Event",	
	["|cff00ff00Les Daily ont été réinitialisées|r"] = "|cff00ff00Daily quests have been reinitialized|r",
	["|cffff0000Les Weekly ont été réinitialisées|r"] = "|cffff0000Weekly quests have been reinitialized|r",
	["|cfa913f00Les Bi-Weekly ont été réinitialisées|r"] = "|cfa913f00 Bi-Weekly quests have been reinitialized|r",	
	["Resize"] = "Resize",
	["Options"] = {
		["Options"] = "Settings",
		["Affichage"] = "Display",		
		["Persos"] = "Characters",
		["Warfronts"] = "Warfronts",
		["Infos"] = "Infos",			--need
		["Sélection"] = "Selection",		
		["Sélection des lignes"] = "Line to display",
		["Catégories"] = "Catégories",	--need
		["Largeur de la 1ere colonne"] = "First column width",
		["Largeur par personnages"] = "Character width",		
		["Hauteur des lignes"] = "Line height",		
		["Reset de la position de la fenêtre"] = "Reset the position of the window",		
		["Afficher à la connexion"] = "Display when login",
		["Reset de la base de données"] = "Database reset",		
		["Sélection des personnages"] = "Characters selection",		
		["Ordre de l'affichage"] = "Characters display order",
		["Pseudo plus court"] = "Shorter nickname",
		["Supprimer un personnage"] = "Delete a character",
		["Serveurs"] = "Realms",
		["Actualiser"] = "Save",
		["Annuler"] = "Cancel",		
		["Fermer"] = "Close",
		["Icône sur la minimap"] = "Display minimap icon",		
		},
	["Terminé"] = "|cff00ff00Done|r",
	["Inconnu"] = "|cffff0000Unknown|r",
	["jour"] = "day",
	["jours"] = "days",		
	["Clé"] = "Key",
	["Coffre"] = " Chest",
	["Cœur d'Azeroth"] = "Heart of Azeroth",	
	["Niveau"] = "Level",
	["Prochain niveau"]	= "Next level",	
	["j"] = "d",	
	["Nazjatar daily"] = "Nazjatar daily",
	["Nazjatar weekly"] = "Nazjatar weekly (Mardivas + WB)",	
	["Parangon"] = "Paragon",
	["Personnalisé"] = "Custom",
	["Afficher les informations relatives \nà votre sélection \npar le menu options"] = "Display custom selection",
	["Afficher les informations \nrelatives à BfA uniquement"] = "Display BfA informations only",
	["Afficher les informations \nrelatives à Legion uniquement"] = "Display Legion informations only",	
	["Afficher les informations \nrelatives à WoD uniquement"] = "Display WoD informations only",
	["Afficher les informations \nrelatives à SL uniquement"] = "Display SL informations only",
	["Afficher les informations \nrelatives à DF uniquement"] = "Display DF informations only",	
	["Montures"] = "Mounts",
	["Jouets"] = "Toys",
	["Mascottes"] = "Companions",	
	["Mechagon"] = "Mechagon daily",	
	["Mechagon daily"] = "Daily world quest (850 pts)",
	["Mechagon recycling"] = "Recycling quest (150 pts)",	
	["Mechagon WM"] = "WM Quest (200 pts)",	
	["BFAQuests"] = {
		"War Campaign",
		"Black Dragonflight",
		"Green Dragonflightt",
		"Red Dragonflight",
		"Blue Dragonflight",
		"Hyjal",
		"Malstrom",
		"Nazjatar WQ",
		"Ashjra'kamas",
		},
	["Assaults"] = "N'zoth Assaults",
	["Val"] = "Vale of Eternal Blossoms",	
	["MiniVision"] = "Mini-Vision of N'Zoth",
	["Point de Conquête (Cap)"] = "Conquest Cap (500)",
	["Journalières"] = "Daily",		
	["Journalières Côté"] = "Rated Daily",	
	["Quêtes d'Appel aux armes"] = "Call to Armes quests",
	["Bataille de Nazjatar"] = "Battle for Nazjatar",	
	["Champ de Bataille"] = "Battleground",
	["Champ de Bataille Épique"] = "Epic Battleground",	
	["Escarmouche"]	= "Skirmish",
	["Arène 2v2"] = "Arena 2v2",
	["Arène 3v3"] = "Arena 3v3",	
	["Champ de Bataille Côté"] = "Rated Battleground",	
	["TracerLimit"] = "Tracer : WARNING !! The addon can manage a maximum of "..TracerData.CharactersLimit.." characters. Please, use the options panel of the addon to erase characters",
	["Congrégation"] = "Covenant",
	["CongrégationName"] = {
		"Kyrian",
		"Venthyr",
		"Night Fae",
		"Necrolord",
		},
	["Appels"] = "Callings",
	["Donjons de la semaine"] = "Weekly Dungeons",
	["Échelon"] = "Layer",	
	["Quêtes de donjon de la semaine"] = "Weekly Dungeon Quests",
	["Appels"] = "Callings",
	["Quête inconnue"] = "Unknown quest",
	["CF"] = "Great Vault",
	["Weekly Anima"] = "Anima Quest",
	["Quêtes de Bolvar"] = "Bolvar's quests",
	["Ailes complétées"] = "Wings completed",
	["Assaults SL"] = "Covenant assault",
	["Liste des mm+ fait cette semaine"] = "MM+ done this week",
	["Ilvl des récompenses du coffre"] = "Weekly chest ilvl rewards",
	["Coffre"] = "Chest",
	["Donjon journalier"] = "Daily dungeon",
	["Renom"] = "Renown";
	["Camp Aylaag"] = "Aylaag Camp";
	["WQ Course draconique"] = "WQ Dragon Races",
	["WQ Irion ou Sabellian"] = "WQ Irion or Sabellian",
	["Coffres hebdo"] = "Weekly chests",
	["WeeklyChestsName"] = {
		[71033] = "Trial of water (Ohn'ahra)",		--Trial of Water (Ohn'ahra)
		[71995] = "Trial of elements (Chromie)",	--Trial of Elements (Chromie)
		[70906] = "Great Hunt",						--Chasse Maruuk
		[70893] = "Community Feast",				--Festin rohart	
		[70866] = "Dragonbane Keep",				--Siège du donjon du Fléau-des-Dragons
		[74378] = "The Storm's Fury",				--Fureur de l'orage		
		},	
	["Métiers : Connaissances"] = "Professions : Knowledge",
	["Points de connaissance de métier"] = "Knowledge points",
};
