local TracerName, TracerData = ...

local RaidsInfos = {
	--Vanilla
	[48] = "",	--Coeur du Magma
	[50] = "",	--Repaire de l'Aile Noire
	[160] = "",	--Ruines d'Ahn'Qiraj
	[161] = "",	--Temple d'Ahn'Qiraj
	--BC
	[175] = "",	--Karazhan
	[177] = "",	--Repaire de Gruul
	[176] = "",	--Le repaire de Magtheridon
	[194] = "",	--Caverne du Sanctuaire du serpent
	[193] = "",	--L'Oeil
	[195] = "",	--La Bataille du mont Hyjal
	[196] = "",	--Le Temple Noir
	[199] = "",	--Plateau du Puits de Soleil
	--Wotlk
	[239] = "",	--Caveau d'Archavon
	[227] = "",	--Naxxramas
	[224] = "",	--Le Sanctum Obsidien
	[237] = "",	--L'Oeil de l'éternité
	[243] = "",	--Ulduar
	[246] = "",	--L'épreuve du croisé
	[257] = "",	--Repaire d'Onyxia
	[279] = "",	--Citadelle de la Couronne de Glace
	[293] = "",	--Le Sanctum Rubis
	--Cata
	[328] = "",	--Bastion de Baradin
	[313] = "",	--Descente de l'Aile Noire
	[315] = "",	--Le Bastion du crépuscule
	[317] = "",	--Trône des quatre vents
	[361] = "",	--Terres de Feu
	[447] = "",	--L'Âme des dragons
	--MoP
	[531] = "",	--Caveau Mogu'shan
	[533] = "",	--Cœur de la peur
	[535] = "",	--Terrasse Printanière
	[633] = "",	--Trône du tonnerre
	[715] = "",	--Siège d’Orgrimmar
	--WoD
	[895] = "",	--Cognefort
	[898] = "",	--Fonderie des Rochenoires
	[987] = "",	--Citadelle des Flammes infernales
	--Legion
	[1348] = "",	--Le Cauchemar d’émeraude
	[1437] = "",	--Le Jugement des Valeureux
	[1351] = "",	--Palais Sacrenuit
	[1525] = "",	--Tombe de Sargeras
	[1640] = "",	--Antorus, le Trône ardent
	--BfA
	[1889] = "",	--Uldir
	[1942] = "",	--Bataille de Dazar’alor
	[1952] = "",	--Creuset des Tempêtes
	[2014] = "",	--Palais Éternel	
	[2033] = "", 	--Ny'alotha
	--SL
	[2095] = "",	--Castle Nathria
	[2226] = "",	--Sanctume de Domination
	[2288] = "",	--Sépulcre des fondateurs
	--DF
	[2390] = "",	--Caveau des incarnations
};
local LFRInfos = {
	-- Pandarie
	[531] = {
		{id = 527, part=1, total=3, base=1,  parent=531, name=""},	--Caveau Mogu'shan 1 : Gardiens des Mogu’shan
		{id = 528, part=2, total=3, base=4,  parent=531, name=""},	--Caveau Mogu'shan 1 : Le caveau des Mystères		
		},	
	[533] = {
		{id = 529, part=1, total=3, base=1,  parent=533, name=""},	--Cœur de la peur 1 : L’approche de l’effroi
		{id = 834, part=2, total=3, base=4,  parent=533, name=""},	--Cœur de la peur 2 : Le cauchemar de Shek’zeer
		},
	[535] = {
		{id = 834, part=1, total=4, base=1,  parent=535, name=""},	--Terrasse Printanière
		},
	[633] = {
		{id = 610, part=1, total=3, base=1,  parent=633, name=""},	--Trône du tonnerre 1 : Le baroud d’honneur des Zandalari
		{id = 611, part=2, total=3, base=4,  parent=633, name=""},	--Trône du tonnerre 1 : Profondeurs oubliées
		{id = 612, part=3, total=3, base=7,  parent=633, name=""},	--Trône du tonnerre 1 : Salles des Sculpte-Chair
		{id = 613, part=4, total=3, base=10,  parent=633, name=""},	--Trône du tonnerre 1 : Cime des Tempêtes
		},
	[715] = {
		{id = 716, part=1, total=4, base=1,  parent=535, name=""},	--Siège d’Orgrimmar 1 : Val de l’Éternelle tristesse
		{id = 717, part=2, total=4, base=5,  parent=535, name=""},	--Siège d’Orgrimmar 1 :	Les portes de la Vindicte	
		{id = 724, part=3, total=4, base=9,  parent=535, name=""},	--Siège d’Orgrimmar 1 :	Fort-du-Gouffre	
		{id = 725, part=4, total=2, base=12,  parent=535, name=""},	--Siège d’Orgrimmar 1 : La chute				
		},		
	-- Warlods of Draenor
	[895] = {
		{id = 849, part=1, total=3, base=1,  parent=895, name=""},	--Cognefort 1 : Cité fortifiée
		{id = 850, part=2, total=3, base=4,  parent=895, name=""},	--Cognefort 2 :	Sanctum des Arcanes
		{id = 851, part=3, total=1, base=7,  parent=895, name=""},	--Cognefort 3 :	Cime de l’Imperator	
		},
	[898] = {
		{id = 1361, part=1, total=3, base=1,  parent=898, name=""},	--Fonderie des Rochenoires 1 : Forgeresse
		{id = 1360, part=2, total=3, base=4,  parent=898, name=""},	--Fonderie des Rochenoires 2 : La Forge noire
		{id = 1362, part=3, total=3, base=7,  parent=898, name=""},	--Fonderie des Rochenoires 3 : Assemblée de Fer			
		{id = 1359, part=4, total=1, base=10,  parent=898, name=""},	--Fonderie des Rochenoires 4 : Creuset de Main-Noire		
		},
	[987] = {
		{id = 1366, part=1, total=3, base=1,  parent=987, name=""},	--Citadelle des Flammes infernales 1 : Brèche infernale
		{id = 1367, part=2, total=3, base=4,  parent=987, name=""},	--Citadelle des Flammes infernales 2 : Salles de Sang
		{id = 1368, part=3, total=3, base=7,  parent=987, name=""},	--Citadelle des Flammes infernales 2 : Bastion des Ombres
		{id = 1369, part=4, total=3, base=10,  parent=987, name=""},	--Citadelle des Flammes infernales 2 : Cime du Destructeur
		{id = 1370, part=5, total=1, base=13,  parent=987, name=""},	--Citadelle des Flammes infernales 2 : Porte noire			
		},		
	-- Legion
	[1348] = {
		{id = 1287, part=1, total=3, base=1,  parent=1348, name=""}, --Le Cauchemard d'Emeraude 1 : Sombranche
		{id = 1288, part=2, total=3, base=4,  parent=1348, name=""}, --Le Cauchemard d'Emeraude 2 : Gardiens tourmentés
		{id = 1289, part=3, total=1, base=7,  parent=1348, name=""}, --Le Cauchemard d'Emeraude 3 : Faille d’Aln
		},
	[1351] = {
		{id = 1290, part=1, total=3, base=1,  parent=1351, name=""}, --Palais Sacrenuit 1 : Les Arcqueducs
		{id = 1291, part=2, total=3, base=4,  parent=1351, name=""}, --Palais Sacrenuit 2 : Athenaeum royal
		{id = 1292, part=3, total=3, base=7,  parent=1351, name=""}, --Palais Sacrenuit 3 : Nocteflèche
		{id = 1293, part=4, total=1, base=10, parent=1351, name=""}, --Palais Sacrenuit 4 : L’ascension du Traître
		},
	[1437] = {
		{id = 1411, part=0, total=3, base=1,  parent=1437, name=""}, --Le Jugement de Valeureux
		},
	[1525] = {
		{id = 1494, part=1, total=3, base=1,  parent=1525, name=""}, --Tombe de Sargeras 1 : Les portes de l’enfer
		{id = 1495, part=2, total=3, base=4,  parent=1525, name=""}, --Tombe de Sargeras 2 : Salles des Lamentations
		{id = 1496, part=3, total=2, base=7,  parent=1525, name=""}, --Tombe de Sargeras 3 : Chambre de l’Avatar
		{id = 1497, part=4, total=1, base=9,  parent=1525, name=""}, --Tombe de Sargeras 4 : La chute du Trompeur
		},
	[1640] = {
		{id = 1610, part=1, total=3, base=1,  parent=1640, name=""}, --Antorus 1 : La Brèche de Lumière
		{id = 1611, part=2, total=3, base=4,  parent=1640, name=""}, --Antorus 2 : La Descente interdite
		{id = 1612, part=3, total=3, base=7,  parent=1640, name=""}, --Antorus 3 : La Fin de l’espoir
		{id = 1613, part=4, total=2, base=10, parent=1640, name=""}, --Antorus 4 : Le Siège du Panthéon		
		},
	-- Battle for Azeroth
	[1889] = {
		{id = 1731, part=1, total=3, base=1, parent=1889, name=""}, --Uldir 1 : Salles de confinement
		{id = 1732, part=2, total=3, base=4, parent=1889, name=""}, --Uldir 2 : Descente Cramoisie
		{id = 1733, part=3, total=2, base=7, parent=1889, name=""}, --Uldir 3 : Cœur de la Corruption
		},
	[1942] = {
		{id = 1945, part=1, total=3, base=1, parent=1942, name=""}, --Bataille de Dazar'alor 1 : Siège de Dazar’alor (Alliance)
		{id = 1946, part=2, total=3, base=4, parent=1942, name=""}, --Bataille de Dazar'alor 2 : La chute de l’empire (Alliance)
		{id = 1947, part=3, total=3, base=7, parent=1942, name=""}, --Bataille de Dazar'alor 3 : La puissance de l’Alliance (Alliance)
		},
	[1944] = {	
		{id = 1948, part=1, total=3, base=1, parent=1944, name=""}, --Bataille de Dazar'alor 1 : Défense de Dazar’alor (Horde)
		{id = 1949, part=2, total=3, base=4, parent=1944, name=""}, --Bataille de Dazar'alor 2 : Le marché avec la mort (Horde)
		{id = 1950, part=3, total=3, base=7, parent=1944, name=""}, --Bataille de Dazar'alor 3 : La victoire ou la mort (Horde)
		},
	[1952] = {
		{id = 1951, part=0, total=2, base=1, parent=1952, name=""}, --Creuset des Tempêtes	
		},
	[2014] = {
		{id = 2009, part=1, total=2, base=1, parent=2014, name=""}, --Palais Éternel 1 : La grande réception
		{id = 2010, part=2, total=2, base=3, parent=2014, name=""}, --Palais Éternel 2 : Les profondeurs des fidèles
		{id = 2011, part=3, total=2, base=5, parent=2014, name=""}, --Palais Éternel 3 : Le cercle des astres
		},	
	[2033] = {
		{id = 2036, part=1, total=3, base=1, parent=2033, name=""}, --Ny'alotha 1 : Vision de la destinée
		{id = 2037, part=2, total=3, base=4, parent=2033, name=""}, --Ny'alotha 2 : Salles de la Dévotion
		{id = 2038, part=3, total=3, base=7, parent=2033, name=""}, --Ny'alotha 3 : Don de chair
		{id = 2039, part=4, total=3, base=10, parent=2033, name=""}, --Ny'alotha 3 :	Le Rêve éveillé
		},	
	--SL
	[2095] = {
		{id = 2090, part=1, total=3, base=1, parent=2095, name=""}, --Nathria 1 : Caveaux drainants
		{id = 2091, part=2, total=3, base=4, parent=2095, name=""}, --Nathria 2 : Reliquaire de l'opulence
		{id = 2092, part=3, total=3, base=7, parent=2095, name=""}, --Nathria 3 : Le sang de la pierre
		{id = 2096, part=4, total=1, base=10, parent=2095, name=""}, --Nathria 4 :	Audience avec l'arrogance
		},
	[2226] = {
		{id = 2221, part=1, total=3, base=1, parent=2095, name=""}, --Sanctum de Domination 1 : L'avant garde du Geolier
		{id = 2222, part=2, total=3, base=4, parent=2095, name=""}, --Sanctum de Domination 2 : La bastille Noire
		{id = 2223, part=3, total=3, base=7, parent=2095, name=""}, --Sanctum de Domination 3 : Les entraves du destin
		{id = 2224, part=4, total=1, base=10, parent=2095, name=""}, --Sanctum de Domination 4 : Le châtiment
		},
	[2288] = {
		{id = 2292, part=1, total=4, base=1, parent=2288, name=""}, --Sépulcre des fondateurs 1 : Plaines ephemeres
		{id = 2291, part=2, total=3, base=5, parent=2288, name=""}, --Sépulcre des fondateurs 2 : Assise de la Création
		{id = 2293, part=3, total=3, base=8, parent=2288, name=""}, --Sépulcre des fondateurs 3 : Emprise de la domination
		{id = 2294, part=4, total=1, base=11, parent=2288, name=""}, --Sépulcre des fondateurs 4 : Le Grand dessein
		},
	--DF
	[2390] = {
		{id = 2370, part=1, total=3, base=1, parent=2390, name=""}, --Caveau des Incarnations 1 : Rempart primordial
		{id = 2371, part=2, total=3, base=4, parent=2390, name=""}, --Sépulcre des fondateurs 2 : Assise de la Création
		{id = 2372, part=3, total=2, base=7, parent=2390, name=""}, --Sépulcre des fondateurs 3 : Emprise de la domination
		},
};
local DifficultyIdInfos = {
	[3] = {"I", "10N"},
	[4] = {"H", "25N"},
	[5] = {"G", "10H"},
	[6] = {"F", "25H"},
	[7] = {"D", "R"},
	[9] = {"J", "40"},
	[14] = {"C", "N"},
	[15] = {"B", "H"},
	[16] = {"A", "M"},
	[17] = {"D", "R"},
	[151] = {"D", "R"},
	};

function TracerData.Function:WindowCreateRaidLockout()
	--DB
	for key, value in pairs(RaidsInfos) do
		local name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _  = GetLFGDungeonInfo(key);
		RaidsInfos[key] = name2;
	end
	for key, value in pairs(LFRInfos) do
		for key1, value1 in pairs(value) do
			name, _, _, _, _, _, _, _, _, _, _, difficulty, _, _, _, _, _, _, name2, _ = GetLFGDungeonInfo(value1.id);
			value1["name"] = name;
		end
	end	
	--Création de la liste des lignes
	TracerDB.ListLine[6] = TracerData.Function:RaidSortList();	
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[6];
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(6, headername);

	--Affichage pour les lignes
	TracerData.RaidNameDDM = {};
	for index, value in ipairs(TracerDB.ListLine[6]) do
		local parts = {strsplit(':', TracerDB.ListLine[6][index])}
		local raidDifficulty = parts[1];					
		local raidId = tonumber(parts[2]);
		--Difficulté
		for key1, value1 in pairs(DifficultyIdInfos) do
			if value1[1] == raidDifficulty then
				difficulty = value1[2];
				break
			end
		end		
		--Noms
		name = RaidsInfos[raidId];	
		TracerData.Lines[6][index]["Title"]:SetText(name.." ("..difficulty..")")
		TracerData.RaidNameDDM[index] = name.." ("..difficulty..")";
	end
	--Affichage pour les Toons
	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[6] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[6]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--Comptage					
					local kill = 0;	--nombre de kill
					local j = 0;	--nombre de boss
					if (value1.Instances[TracerDB.ListLine[6][i]] ~= nil) then
						for index2, value2 in ipairs(value1.Instances[TracerDB.ListLine[6][i]]) do
							j = j + 1;
							if value2[2] then
								kill = kill + 1;
							end
						end						
					end
					--Affichage
					if kill == 0 then
						TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(nil);	--pas de texte
					elseif kill == j then				
						--Affichage pour le Toon
						TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(nil);						
						TracerData.Lines[6]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
					else							
						--Affichage pour le Toon					
						TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(kill.."/"..j);
					end						
				end
			end
		end
	end	
	
	--Tooltip pour les vérouillages de raid
	for index1, value1 in ipairs(TracerData.ListToons) do
		for index2, value2 in ipairs(TracerDB.ListLine[6]) do	
			TracerData.Lines[6]["Toon"..index1][index2]:SetScript("OnEnter", function()
				TracerData.Function:RNHMTooltip(value1, value2);
			end);
			TracerData.Lines[6]["Toon"..index1][index2]:SetScript("OnLeave", function()
				GameTooltip:Hide();
			end);
		end
	end

	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end
	
	--Gestion de l'état
	TracerData.Headers[1]:RegisterEvent("PLAYER_ENTERING_WORLD");	
	TracerData.Headers[1]:RegisterEvent("BOSS_KILL");
	TracerData.Headers[1]:RegisterEvent("UPDATE_INSTANCE_INFO");
	TracerData.Headers[1]:SetScript("OnEvent", function(_, event, ...)
		if event == "UPDATE_INSTANCE_INFO" then
			TracerData.Headers[1]:UnregisterEvent("UPDATE_INSTANCE_INFO");
			C_Timer.After(5, function() TracerData.Function:RNHMUpdate() end)
		else
			RequestRaidInfo();
		end		
		end);
end

function TracerData.Function:RaidSortList()
	--Recherche des différents vérouillages sur les persos
	local list = {};
	local j = 1;
	--Contruction de la liste avec les doublons
	for index, value in ipairs(TracerData.ListToons) do
		for key1, value in pairs(TracerDB.Toons[value]["Instances"]) do
			list[j] = key1
			j = j + 1;
		end	
	end
	
	--On retire les doublons
	local hash = {}
	local res = {}
	for index, value in ipairs(list) do
		if (not hash[value]) then
			res[#res+1] = value
			hash[value] = true
		end
	end
	--On range dans l'ordre	
	local t = {};
	for index, value in ipairs(res) do
		local parts = {strsplit(':', res[index])}
		local raidDifficulty = parts[1];					
		local raidId = tonumber(parts[2]);
		t[index] = {raidId, raidDifficulty}
	end
	table.sort(t, function(a,b) return b[1]<a[1] end);	
	
	local listsort = {}
	for index, value in ipairs(t) do
		listsort[index] = tostring(value[2])..":"..value[1];
	end
	
	return listsort;	
end

function TracerData.Function:RNHMUpdate()
	--Récupération des informations OutilRaid/Normal/Heroic/Mythic	
	local InstanceLockInfo = TracerData.Function:GetLockInstance();

	if InstanceLockInfo == nil then return end
	for index, value in ipairs(InstanceLockInfo) do			
		if value.reset ~= 0 then
			for key1, value1 in pairs(RaidsInfos) do
				if value.name == value1 then
					TracerDB.Toons[TracerData.thisToon]["Instances"][DifficultyIdInfos[value.difficulty][1]..":"..key1] = {};
					TracerDB.Toons[TracerData.thisToon]["Instances"][DifficultyIdInfos[value.difficulty][1]..":"..key1]["name"] = value.name;					
					TracerDB.Toons[TracerData.thisToon]["Instances"][DifficultyIdInfos[value.difficulty][1]..":"..key1]["difficulty"] = DifficultyIdInfos[value.difficulty];					
					for i=1, value.numEncounters do
						local bossName, _, isKilled, _ = GetSavedInstanceEncounterInfo(index, i);
						TracerDB.Toons[TracerData.thisToon]["Instances"][DifficultyIdInfos[value.difficulty][1]..":"..key1][i] = {bossName, isKilled}						
					end
				end
			end
		end
	end
	
	--Affichage
	local listline = TracerData.Function:RaidSortList();
	if #listline == #TracerDB.ListLine[6] then		--Si pas de nouvelle ligne
		for i=1, #TracerDB.ListLine[6], 1 do
			--Comptage				
			local kill = 0;	--nombre de kill
			local j = 0;	--nombre de boss
			if TracerDB.Toons[TracerData.thisToon]["Instances"][TracerDB.ListLine[6][i]] then						
				for index2, value2 in ipairs(TracerDB.Toons[TracerData.thisToon]["Instances"][TracerDB.ListLine[6][i]]) do
					j = j + 1;
					if value2[2] then
						kill = kill + 1;
					end
				end						
			end
			--Affichage
			if kill == 0 then
				TracerData.Lines[6]["Toon"..TracerData.numthisToon][i]["Title"]:SetText(nil);	--pas de texte
			elseif kill == j then				
				--Affichage pour le Toon
				TracerData.Lines[6]["Toon"..TracerData.numthisToon][i]["Title"]:SetText(nil);						
				TracerData.Lines[6]["Toon"..TracerData.numthisToon][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
			else							
				--Affichage pour le Toon
				TracerData.Lines[6]["Toon"..TracerData.numthisToon][i]["Title"]:SetText(kill.."/"..j);
			end	
		end
	else --Si c'est un nouveau raid
		if TracerDB.ListLine[6][1] == nil then
			TracerData.Buttons["6minus"]:Show();
			TracerData.Buttons["6plus"]:Hide();			
		end
		for i = 1, #listline-#TracerDB.ListLine[6], 1 do
			TracerData.Function:CreateLine(6, listline[i]);
		end 
		
		--Affichage pour les lignes
		for index, value in ipairs(listline) do
			local parts = {strsplit(':', listline[index])}
			local raidDifficulty = parts[1];					
			local raidId = tonumber(parts[2]);
			for key1, value1 in pairs(DifficultyIdInfos) do
				if value1[1] == raidDifficulty then
					TracerData.Lines[6][index]["Title"]:SetText(RaidsInfos[raidId].." ("..value1[2]..")");
					break
				end
			end		
		end
		--Affichage pour les Toons
		for index, value in ipairs(TracerData.ListToons) do			
			if TracerData.Lines[6]["Toon"..index] ~= nil then
				for i = 1, #listline , 1 do
					for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
						if value == key1 then
							-- Comptage					
							local kill = 0;	--nombre de kill
							j = 0;	--nombre de boss
							if (value1.Instances[listline[i]] ~= nil) then
								for index2, value2 in ipairs(value1.Instances[listline[i]]) do
									j = j + 1;
									if value2[2] then
										kill = kill + 1;
									end
								end						
							end
							-- Affichage
							if kill == 0 then
								TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(nil);	--pas de texte
								TracerData.Lines[6]["Toon"..index][i]["Texture2"]:SetTexture(nil);	--pas de texture
							elseif kill == j then				
								-- Affichage pour le Toon
								TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(nil);						
								TracerData.Lines[6]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
							else							
								-- Affichage pour le Toon					
								TracerData.Lines[6]["Toon"..index][i]["Title"]:SetText(kill.."/"..j);
								TracerData.Lines[6]["Toon"..index][i]["Texture2"]:SetTexture(nil);	--pas de texture
							end						
						end
					end
				end
			end
		end
		--Tooltip pour les vérouillages de raid
		for index, value in ipairs(TracerData.ListToons) do
			for index2, value2 in ipairs(listline) do	
				TracerData.Lines[6]["Toon"..index][index2]:SetScript("OnEnter", function()
					TracerData.Function:RNHMTooltip(value, value2);
				end);
				TracerData.Lines[6]["Toon"..index][index2]:SetScript("OnLeave", function()
					GameTooltip:Hide();
				end);
			end
		end
	end
	--Mise à jour des ancrages
	TracerData.Function:UpdateAnchors()
	--Pour déclencher à nouveau la mise à jour
	TracerData.Headers[1]:RegisterEvent("UPDATE_INSTANCE_INFO");
end

function TracerData.Function:RNHMTooltip(toon, InstanceId)
	if TracerDB.Toons[toon]["Instances"][InstanceId] == nil then return end	--pas de Tooltip si pas de lock

	local parts = {strsplit(':', InstanceId)}
	local raidDifficulty = parts[1];					
	local raidId = tonumber(parts[2]);	

	for key, value in pairs(DifficultyIdInfos) do
		if value[1] == raidDifficulty then
			raidDifficulty = value[2];
			break
		end
	end
	local name = RaidsInfos[raidId];
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"];	
    GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
    GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], name.." ("..raidDifficulty..")", r, g, b, 1, 1, 1);
	
	if raidDifficulty == "R" then
		for key, value in pairs(LFRInfos[raidId]) do
			if raidId == 2288 then	--Sépulcre des fondateurs
				local bossorder = {1,3,5,6,2,4,7,8,9,10,11}
				GameTooltip:AddLine(value["name"]);
				local firstboss = value.base;
				local lastboss = firstboss+value.total-1;
				for j=firstboss, lastboss, 1 do
					if TracerDB.Toons[toon]["Instances"][InstanceId][bossorder[j]][2] then
						GameTooltip:AddLine("   "..TracerDB.Toons[toon]["Instances"][InstanceId][bossorder[j]][1], 0, 1, 0);
					else
						GameTooltip:AddLine("   "..TracerDB.Toons[toon]["Instances"][InstanceId][bossorder[j]][1], 1, 0, 0);
					end
				end			
			else
				local firstboss = value.base;
				local lastboss = firstboss+value.total-1;
				for j=firstboss, lastboss, 1 do
					if TracerDB.Toons[toon]["Instances"][InstanceId][j][2] then
						GameTooltip:AddLine("   "..TracerDB.Toons[toon]["Instances"][InstanceId][j][1], 0, 1, 0);
					else
						GameTooltip:AddLine("   "..TracerDB.Toons[toon]["Instances"][InstanceId][j][1], 1, 0, 0);
					end
				end
			end	
		end
	else
		for index, value in ipairs(TracerDB.Toons[toon]["Instances"][InstanceId])	do
			if value[2] then
				GameTooltip:AddLine(value[1], 0, 1, 0);
			else
				GameTooltip:AddLine(value[1], 1, 0, 0);
			end
		end
	end
	
	GameTooltip:Show();
end




