local TracerName, TracerData = ...
local CovenantTexture = {
	"Interface\\AddOns\\Tracer\\Fonts\\covenant\\kyrian",	--Kyrian
	"Interface\\AddOns\\Tracer\\Fonts\\covenant\\venthyr",	--Venthyr
	"Interface\\AddOns\\Tracer\\Fonts\\covenant\\nightfae",	--Night Fae
	"Interface\\AddOns\\Tracer\\Fonts\\covenant\\necrolords",	--Necrolord
};
local WeeklyDungeonQuestsId = {
	60242,	--NW
	60243,	--SD
	60244,	--HoA
	60245,	--TOS
	60246,	--MoTS
	60247,	--ToP
	60248,	--Pl
	60249,	--SoA
	--
	60250,	--ToP
	60251,	--Pl
	60252,	--SoA
	60253,	--NW
	60254,	--MoTS
	60255,	--ToS
	60256,	--HoA
	60257,	--SD
};
TracerData.TorghastDungeonIds = {
	--Salle de Skoldus
	2100,	--1
	2128,	--2
	2129,	--3
	2130,	--4
	2131,	--5
	2132,	--6
	2133,	--7
	2134,	--8
	2197,	--9
	2198,	--10
	2199,	--11
	2200,	--12
	2295,	--13
	2296,	--14
	2297,	--15	
	2298,	--16	
	--Chambres aux Fractures
	2101,	--1
	2135,	--2
	2136,	--3
	2137,	--4
	2138,	--5
	2139,	--6
	2140,	--7
	2141,	--8
	2201,	--9
	2202,	--10
	2203,	--11
	2204,	--12
	2299,	--13
	2300,	--14
	2301,	--15	
	2302,	--16		
	--Forges des âmes
	2102,	--1
	2142,	--2
	2143,	--3
	2144,	--4
	2145,	--5
	2146,	--6
	2147,	--7
	2148,	--8
	2205,	--9
	2206,	--10
	2207,	--11
	2208,	--12
	2303,	--13
	2304,	--14
	2305,	--15	
	2306,	--16			
	--Interstice Coeur-Algide
	2103,	--1
	2149,	--2
	2150,	--3
	2151,	--4
	2152,	--5	
	2153,	--6
	2154,	--7
	2155,	--8
	2209,	--9
	2210,	--10
	2211,	--11
	2212,	--12
	2307,	--13
	2308,	--14
	2309,	--15	
	2310,	--16		
	--Mort'regar
	2104,	--1
	2156,	--2
	2157,	--3
	2158,	--4
	2159,	--5
	2160,	--6
	2161,	--7
	2162,	--8
	2213,	--9
	2214,	--10
	2215,	--11
	2216,	--12
	2311,	--13
	2312,	--14
	2313,	--15	
	2314,	--16		
	--Etages supérieurs
	2105,	--1
	2163,	--2
	2164,	--3
	2165,	--4
	2166,	--5
	2167,	--6
	2168,	--7
	2169,	--8
	2217,	--9
	2218,	--10
	2219,	--11
	2220,	--12
	2315,	--13
	2316,	--14
	2317,	--15	
	2318,	--16		
	--Couloirs Distordus
	2106,	--1
	2170,	--2
	2771,	--3
	2172,	--4
	2173,	--5
	2174,	--6
	2175,	--7
	2176,	--8		
};
local WBSLInfo = {};
local TorghastWingsEnd = {
	2298,
	2302,
	2306,
	2310,
	2314,
	2318,
	};
local TorghastWingsStart = {
	2100,
	2101,
	2102,
	2103,
	2104,
	2105,
};

function TracerData.Function:WindowCreateShadowlands()
	--DB
	WBSLInfo = {
	[61816] = {TracerData.L.WBSL[173104], C_Map.GetMapInfo(1536).name},	--Mortanis - Maldraxxus
	[61815] = {TracerData.L.WBSL[167527], C_Map.GetMapInfo(1565).name},	--Oranomonos - Sylvarden
	[61814] = {TracerData.L.WBSL[167526], C_Map.GetMapInfo(1525).name},	--Nurgash - Revendredth	
	[61813] = {TracerData.L.WBSL[167524], C_Map.GetMapInfo(1533).name},	--Valinor - Bastion

	[66614] = {TracerData.L.WBSL[167524], C_Map.GetMapInfo(1533).name},	--Valinor - Bastion (Fortifié)
	[66615] = {TracerData.L.WBSL[167526], C_Map.GetMapInfo(1525).name},	--Nurgash - Revendredth (Fortifié)
	[66617] = {TracerData.L.WBSL[173104], C_Map.GetMapInfo(1536).name},	--Mortanis - Maldraxxus (Fortifié)
	[66616] = {TracerData.L.WBSL[167527], C_Map.GetMapInfo(1565).name},	--Oranomonos - Sylvarden (Fortifié)
	};
	
	--Informations pour la création de la catégorie
	local headername = TracerData.L.Headers[9];
	--local _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, name2, _ = GetLFGDungeonInfo(1963)	--id random juste pour le nom
	TracerDB.ListLine[9] = {
		TracerData.L["Congrégation"],
		TracerData.L["Appels"],
		--name2,	
		TracerData.L["Donjons de la semaine"],
		"WB SL",
		TracerData.L["Weekly Anima"],
		TracerData.L["Assaults SL"],
		"Korthia - Weekly",
		"Korthia - Daily",
		"Korthia - WB Mor'geth",
		"Korthia - WQ",
		"ZM - Weekly",
		"ZM - WB Antros",
		};
	
	--Création de la catégorie
	TracerData.Function:WindowCreate(9, headername);
	
	--Affichage
	TracerData.Function:WindowUpdateShadowlands();

	--Tooltip
	--Tooltip pour les Callings
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[9]["Toon"..index][2]:SetScript("OnEnter", function()
		TracerData.Function:CallingsTooltip(value);
		end);
		TracerData.Lines[9]["Toon"..index][2]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end	
	
	-- --Tooltip pour les quantité de Cendre d'âme par étage
	-- TracerData.Lines[9][3]:SetScript("OnEnter", function()
		-- TracerData.Function:TorghastSoulAshLayerTooltip();
	-- end);
	-- TracerData.Lines[9][3]:SetScript("OnLeave", function()
		-- GameTooltip:Hide();
	-- end);
	
	-- --Tooltip pour les lock de Torghast
	-- for index, value in ipairs(TracerData.ListToons) do
		-- TracerData.Lines[9]["Toon"..index][3]:SetScript("OnEnter", function()
		-- TracerData.Function:TorghastLockoutTooltip(value);
		-- end);
		-- TracerData.Lines[9]["Toon"..index][3]:SetScript("OnLeave", function()
			-- GameTooltip:Hide();
		-- end);	
	-- end	

	--Tooltip pour les WeeklyDungeonQuests
	for index, value in ipairs(TracerData.ListToons) do
		TracerData.Lines[9]["Toon"..index][3]:SetScript("OnEnter", function()
		TracerData.Function:WeeklyDungeonQuestsTooltip(value);
		end);
		TracerData.Lines[9]["Toon"..index][3]:SetScript("OnLeave", function()
			GameTooltip:Hide();
		end);	
	end

	--Tooltip pour les Quêtes
	-- for index, value in ipairs(TracerData.ListToons) do
		-- TracerData.Lines[9]["Toon"..index][5]:SetScript("OnEnter", function()
		-- TracerData.Function:SLQuestsTooltip(value);
		-- end);
		-- TracerData.Lines[9]["Toon"..index][5]:SetScript("OnLeave", function()
			-- GameTooltip:Hide();
		-- end);	
	-- end	
	
	
	if not TracerDB.Toons[TracerData.thisToon]["Display"] then return end

	--Déclanchements
	--Gestion Congrégation
	TracerData.Lines[9][1]:RegisterEvent("COVENANT_CHOSEN");	
	TracerData.Lines[9][1]:SetScript("OnEvent", function(_, event, arg1) 
		if event == "COVENANT_CHOSEN" then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["CovenantID"] = arg1;
			--TracerData.Function:WindowUpdateShadowlands();
		end
		end)
		
	--Gestion des Appels
	TracerData.Lines[9][2]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[9][2]:RegisterEvent("QUEST_LOG_UPDATE");
	TracerData.Lines[9][2]:RegisterEvent("COVENANT_CALLINGS_UPDATED");
	TracerData.Lines[9][2]:SetScript("OnEvent", function(_, event, arg1, arg2, arg3) 
		TracerData.Function:ShadowlandsQuestsChecking();
		if event == "COVENANT_CALLINGS_UPDATED" then
			TracerData.Function:CallingsChecking(arg1);	--Fonction scan pour avoir les 3 appels en cours
		else
			C_CovenantCallings.RequestCallings();		
		end
		end)
		
	-- --Gestion Torghast
	-- TracerData.Lines[9][3]:RegisterEvent("SHOW_LOOT_TOAST");
	-- TracerData.Lines[9][3]:SetScript("OnEvent", function(_, event, arg1, arg2) 
		-- --print(event);
		-- TracerData.Function:TorghastChecking(event, arg1, arg2);		
		-- end)		
		
	--Gestion des Weekly Dungeons Quests
	TracerData.Lines[9][3]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[9][3]:RegisterEvent("QUEST_LOG_UPDATE");	
	TracerData.Lines[9][3]:SetScript("OnEvent", function(_, event) 
			C_Timer.After(3, function() TracerData.Function:WeeklyDungeonsQuestsChecking(); end)					
		end)	
		
	--Gestion du WB de SL
	TracerData.Lines[9][4]:RegisterEvent("QUEST_TURNED_IN");
	TracerData.Lines[9][4]:SetScript("OnEvent", function(_, event) 
		C_Timer.After(3, function() TracerData.Function:WorldBossCheckingSL() end) 
	end)		
end

function TracerData.Function:WindowUpdateShadowlands()
	local j = 0;

	for index, value in ipairs(TracerData.ListToons) do
		for i = 1, #TracerDB.ListLine[9] , 1 do
			for key1, value1 in pairs(TracerDB.Toons) do	--On va chercher les informations pour le bon Toon				
				if value == key1 then
					TracerData.Lines[9]["Toon"..index][i]["Title"]:SetTextColor(value1.ClassColor.r, value1.ClassColor.g, value1.ClassColor.b, 1);
					--"Congrégation"
					if i == 1 then
						if value1.Quests.SL.CovenantID == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:ClearAllPoints();
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetPoint("CENTER", TracerData.Lines[9]["Toon"..index][i], "CENTER", 0, 0);														
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");	
							TracerData.Lines[9]["Toon"..index][i]["Title"]:ClearAllPoints();
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetPoint("CENTER", TracerData.Lines[9]["Toon"..index][i], "CENTER", 0, 0);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);														
						else
							TracerData.Lines[9]["Toon"..index][i]["Title"]:ClearAllPoints();
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetPoint("CENTER", TracerData.Lines[9]["Toon"..index][i], "CENTER", 7, 0);							
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1.Quests.SL.CovenantRenownLevel);	
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:ClearAllPoints();
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetPoint("CENTER", TracerData.Lines[9]["Toon"..index][i], "CENTER", -7, 0);														
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(CovenantTexture[value1.Quests.SL.CovenantID]);							
						end
					end	
					--"Appels"
					if i == 2 then
						if (value1.Level < 60) or (not value1.Quests.SL.CallingsUnlocked) then	
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						else
							j = 0;
							for index, value in pairs(value1.Quests.SL.Callings) do
								if value[2] then
									j = j + 1;
								end
							end
							if j == 3 then														
								TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");		
							else
								TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(j.."/3");
								TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);		
							end
						end			
					end						
					--"Weekly donjons"
					if i == 3 then
						if not value1.Quests.SL.WeeklyDungeonQuestsUnlocked then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
						else
							j = 0;
							for index2, value2 in ipairs(value1.Quests.SL.WeeklyDungeonQuests) do
								if value2 == -1 then
									j = j + 1;
								end
							end
							if j == 2 then														
								TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
								TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
							else
								j = 0;
								for index2, value2 in ipairs(value1.Quests.SL.WeeklyDungeonQuests) do
									if value2 == 1 then
										j = j + 1;
									end
								end
								if j == 2 then
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								else
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(j.."/2");
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);		
								end
							end
						end
					end
					--"WB SL"
					if i == 4 then
						TracerData.Lines[9][i]["Title"]:SetText("WB SL : "..TracerDB.WBSL);
						if value1["Quests"]["SL"]["WBSL"] == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1["Quests"]["SL"]["WBSL"] == 1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						end
					end	
					--"Quêtes SL"
					if i == 5 then
						TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
						TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						if value1.Level < 60 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
						elseif value1.Quests.SL.Quests[2] == 1001 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						elseif value1.Quests.SL.Quests[2] == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");												
						else
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1.Quests.SL.Quests[2]);
						end
					end
					--Assaut de congrégation
					if i == 6 then
						TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
						if value1["Quests"]["SL"]["AssaultMaw"] == 1 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						else
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						end						
					end
					--Korthia Weekly
					if i == 7 then
						TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
						if value1["Quests"]["SL"]["KorthiaWeekly"] == 101 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						elseif value1["Quests"]["SL"]["KorthiaWeekly"] == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						else
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["SL"]["KorthiaWeekly"].." %");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						end						
					end				
					--Korthia Daily
					if i == 8 then
						if value1["Quests"]["SL"]["KorthiaDaily"] == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);							
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						else
							if value1.Quests.SL.Quests[3] >= 1 then
								if value1["Quests"]["SL"]["KorthiaDaily"] >= 4 then
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								else
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["SL"]["KorthiaDaily"].."/4");
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
								end
							else
								if value1["Quests"]["SL"]["KorthiaDaily"] == 3 then
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
								else
									TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["SL"]["KorthiaDaily"].."/3");
									TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);						
								end							
							end
						end						
					end
					--Korthia WB
					if i == 9 then
						if value1.Quests.SL.KorthiaWB == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						elseif value1.Quests.SL.KorthiaWB == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1.Quests.SL.KorthiaWB == 1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						end						
					end
					--Korthia WQ
					if i == 10 then
						if value1.Quests.SL.KorthiaWQ == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						elseif value1.Quests.SL.KorthiaWQ == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1.Quests.SL.KorthiaWQ == 1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						end						
					end	
					--ZM Weekly
					if i == 11 then
						TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
						if value1["Quests"]["SL"]["ZMWeekly"] == 101 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						elseif value1["Quests"]["SL"]["ZMWeekly"] == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						else
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(value1["Quests"]["SL"]["ZMWeekly"].." %");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						end						
					end						
					--ZM WB
					if i == 12 then
						if value1.Quests.SL.ZMWB == -1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText("NA");
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture(nil);
						elseif value1.Quests.SL.ZMWB == 0 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareRed");
						elseif value1.Quests.SL.ZMWB == 1 then
							TracerData.Lines[9]["Toon"..index][i]["Title"]:SetText(nil);
							TracerData.Lines[9]["Toon"..index][i]["Texture2"]:SetTexture("Interface\\AddOns\\Tracer\\Fonts\\SquareGreen");
						end						
					end
					
				end
			end
		end
	end
end

--Fonction scans
function TracerData.Function:CallingsChecking(CallingsInfo)
	if not CallingsInfo then return end

	local t = {false, false, false};
	--Scan des quêtes disponibles
	for index, value in ipairs(CallingsInfo) do
		if (C_TaskQuest.GetQuestTimeLeftSeconds(value.questID)) and (C_TaskQuest.GetQuestTimeLeftSeconds(value.questID) < 86400) then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["Callings"][1][1] = value.questID;
			t[1] = true;
		elseif (C_TaskQuest.GetQuestTimeLeftSeconds(value.questID)) and (C_TaskQuest.GetQuestTimeLeftSeconds(value.questID) < 172800) then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["Callings"][2][1] = value.questID;
			t[2] = true;			
		elseif C_TaskQuest.GetQuestTimeLeftSeconds(value.questID) then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["Callings"][3][1] = value.questID;
			t[3] = true;			
		end
	end
	--Correction si pas de quêtes
	for index, value in ipairs(t) do
		if not t[index] then
			TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["Callings"][index] = {0, true};			
		end
	end	
	--Checking des Callings
	for index, value in ipairs(TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["Callings"]) do
		if value[1] ~= 0 then
			value[2] = C_QuestLog.IsQuestFlaggedCompleted(value[1]);
		end
	end
end

function TracerData.Function:ShadowlandsQuestsChecking()
	local idquestssouls = {
		61331,
		61332,
		61333,
		61334,
		
		62858,
		62861,
		62864,
		62867,
		
		62859,
		62862,
		62865,
		62868,
		
		62860,
		62863,
		62866,
		62869,
	};
	local idquestsanima = {
		61981,	--Venthyr
		61982,	--Transcendés
		61983,	--Armée immortelle
		61984,	--NF
	};
	TracerData.idquestsbolvar = {
		62932,
		62935,
		62938,
		60139,
		62966,
		62969,
		60146,
		62836,
		61730,
		};
	TracerData.idquestscampaign = {
		63727,	--The last Sigil
		63622,	--An Army of Bone ans Steel
		63656,	--The Unseen Guests
				--The Power of Night
				--A New Path
				--What Lies Ahead
		};
	local AssaultMawQuestsIds = {
		63822,	--Venthyr		
		63823,	--NF
		63824,	--Kyrians	
		63543,	--Necrolord
		};
	local KorthiaDailyQuestsIds = {
		63775,
		63776,
		63777,
		63779,
		63780,
		63781,
		63782,
		63783,
		63784,
		63785,
		63786,
		63787,
		63788,
		63789,
		63790,
		63791,
		63792,
		63793,
		63794,
		
		63934,
		63935,
		63936,
		63950,
		63954,
		63955,
		63956,
		63957,
		63958,
		63959,
		63960,
		63961,
		63962,
		63963,
		63964,
		63965,
		63989,
		
		64016,
		64017,
		64018,
		64040,
		64043,
		64065,
		64070,
		64080,
		
		64101,
		64103,
		64104,
		64129,
		64166,
		64194,
		64240,
		64271,
		64432,
		};	
	local j = 0;	
	local objectives = {};	--pour récupérer les informations sur une quêtes en cours
	local progress = 0;		--pour récupérer la progression d'une progressbar d'une quête
	
	--Déblocage des Weekly Dungeons Quests
	TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuestsUnlocked"] = C_QuestLog.IsQuestFlaggedCompleted(60274);

	--Update Renown
	if TracerDB["Toons"][TracerData.thisToon]["Level"] >= 50 then
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["CovenantRenownLevel"] = C_CovenantSanctumUI.GetRenownLevel();	--Renown level			
	end

	--Déblocage de Callings
	TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["CallingsUnlocked"] = C_CovenantCallings.AreCallingsUnlocked();
	
	--Quetes à suivre
	--Âmes à sauver
	local flag = false;
	
	for k=1, #idquestssouls, 1 do
		if C_QuestLog.IsQuestFlaggedCompleted(idquestssouls[k]) then
			flag = true;
		end
	end
	if flag then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][1] = 1;
	else
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][1] = 0;	
	end
	--Remplir le réservoir (anima)
	for k=1, #idquestsanima, 1 do
		if C_QuestLog.IsQuestFlaggedCompleted(idquestsanima[k]) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][2] = 1001;
			break;
		elseif C_QuestLog.GetLogIndexForQuestID(idquestsanima[k]) then
			objectives = C_QuestLog.GetQuestObjectives(idquestsanima[k]);
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][2] = objectives[1]["numFulfilled"];
			break;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][2] = -1;
		end
	end
	--Quête Campagne 9.1
	j = 0;
	for index, value in ipairs(TracerData.idquestscampaign) do
		if C_QuestLog.IsQuestFlaggedCompleted(value) then
			j = j + 1;
		end
	end
	TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][3] = j;
	--Assaut de congrégation
	for index, value in ipairs(AssaultMawQuestsIds) do
		if C_QuestLog.IsQuestFlaggedCompleted(value) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["AssaultMaw"] = 1;
			break;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["AssaultMaw"] = 0;		
		end
	end	
	--Korthia Weekly
	if C_QuestLog.IsQuestFlaggedCompleted(63949) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWeekly"] = 101;
	else
		if C_QuestLog.GetLogIndexForQuestID(63949) then
			progress = GetQuestProgressBarPercent(63949);
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWeekly"] = progress;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWeekly"] = -1;
		end
	end	
	--Korthia Daily
	j = 0;
	for index, value in ipairs(KorthiaDailyQuestsIds) do
		if C_QuestLog.IsQuestFlaggedCompleted(value) then
			j = j + 1;
		end
	end
	TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaDaily"] = j;	
	--Korthia WB
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 60 then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWB"] = -1;
	else
		if C_QuestLog.IsQuestFlaggedCompleted(64531) or C_QuestLog.IsQuestFlaggedCompleted(64531) then	--WB normal ou fortifié
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWB"] = 1;		
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWB"] = 0;		
		end
	end
	--Korthia WQ
	if TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["Quests"][3] < 2 then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWQ"] = -1;
	else
		if C_QuestLog.IsQuestFlaggedCompleted(64273) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWQ"] = 1;		
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["KorthiaWQ"] = 0;		
		end
	end	
	--ZM Weekly	
	if C_QuestLog.IsQuestFlaggedCompleted(66042) then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWeekly"] = 101;
	else
		if C_QuestLog.GetLogIndexForQuestID(66042) then
			progress = GetQuestProgressBarPercent(66042);
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWeekly"] = progress;
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWeekly"] = -1;
		end
	end		
	--ZM WB
	if TracerDB.Toons[TracerData.thisToon]["Level"] < 60 then
		TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWB"] = -1;
	else
		if C_QuestLog.IsQuestFlaggedCompleted(65143) or C_QuestLog.IsQuestFlaggedCompleted(66619) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWB"] = 1;		
		else
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["ZMWB"] = 0;		
		end
	end
	
	
	--Affichage
	--TracerData.Function:WindowUpdateShadowlands();
end

function TracerData.Function:WeeklyDungeonsQuestsChecking()
	if not TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuestsUnlocked"] then return end
	local t = {};
	--Update des quêtes de la semaine (pour la tooltip)
	for k=1, 2, 1 do
		t = {};
		--Si les quêtes ont déjà été rendues
		if k == 1 then
			for index, value in ipairs(WeeklyDungeonQuestsId) do
				if C_QuestLog.IsQuestFlaggedCompleted(value) then
					table.insert(t, value);
				end
			end		
		end
		--Si les quêtes sont dans le QuestLog
		if k == 2 then
			for index, value in ipairs(WeeklyDungeonQuestsId) do
				if C_QuestLog.IsOnQuest(value) then
					table.insert(t, value);
				end
			end
		end
		--Sauvegarde
		table.sort(t);
		for i=1, 2, 1 do
			if t[i] then
				if TracerDB.WeeklyDungeonQuestsIdsSL[1] == 0 then
					TracerDB.WeeklyDungeonQuestsIdsSL[1] = t[i];
					TracerDB.WeeklyDungeonQuestsIdsSL[2] = C_QuestLog.GetTitleForQuestID(t[i]);
				else
					if (TracerDB.WeeklyDungeonQuestsIdsSL[3] == 0) and (TracerDB.WeeklyDungeonQuestsIdsSL[1] ~= t[i]) then
						TracerDB.WeeklyDungeonQuestsIdsSL[3] = t[i];
						TracerDB.WeeklyDungeonQuestsIdsSL[4] = C_QuestLog.GetTitleForQuestID(t[i]);				
					end
				end
				
			end
		end
	end
	
	--Update pour savoir si elle sont faites ou non
	if TracerDB.WeeklyDungeonQuestsIdsSL[1] ~= 0 then
		if C_QuestLog.IsQuestFlaggedCompleted(TracerDB.WeeklyDungeonQuestsIdsSL[1]) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] = 1;
		else			
			if C_QuestLog.GetLogIndexForQuestID(TracerDB.WeeklyDungeonQuestsIdsSL[1]) then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] = 0;
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] = -1;
			end
		end
	end
	if TracerDB.WeeklyDungeonQuestsIdsSL[3] ~= 0 then
		if C_QuestLog.IsQuestFlaggedCompleted(TracerDB.WeeklyDungeonQuestsIdsSL[3]) then
			TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] = 1;
		else			
			if C_QuestLog.GetLogIndexForQuestID(TracerDB.WeeklyDungeonQuestsIdsSL[3]) then
				TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] = 0;
			else
				TracerDB.Toons[TracerData.thisToon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] = -1;
			end
		end
	end

	--Affichage
	--TracerData.Function:WindowUpdateShadowlands();
end

function TracerData.Function:TorghastChecking(event, arg1, arg2)	
	--Détection de la bonne monnaie	
	if event == "SHOW_LOOT_TOAST" then
		if not string.find(arg2, "1828") then return end
	end
	print("Tourment cheking");
	--Détection de la bonne zone
	local flag = false;
	local inInstance, instanceType = IsInInstance();
	local j = 0;
	local LfgDungeonID = 0;
	if inInstance and (instanceType == "scenario") then
		local name, _, _, _, _, _, _, _, _, LfgDungeonID  = GetInstanceInfo();
		local name2 = GetLFGDungeonInfo(LfgDungeonID);
		-- print("LfgDungeonID "..LfgDungeonID.." - "..name);
		-- print("MapID  "..C_Map.GetBestMapForUnit("player"));				
		for index, value in ipairs(TracerData.TorghastDungeonIds) do
			if value == LfgDungeonID then
				j = index;
				flag = true;
			end
		end
	end
	
	--Sauvegarde
	if flag and (LfgDungeonID ~= 0)then
		--print(name2.."  TERMINE");
		TracerDB.Toons[TracerData.thisToon]["Torghast"][LfgDungeonID] = true;
	end
	--Mise à jour si c'est un échelon plus grand que 1 (validation des échelons précédents)
	if j>1 then
		if ((j==12) or (j==24) or (j==36) or (j==48) or (j==60) or (j==72)) then			
			TracerDB.Toons[TracerData.thisToon]["Torghast"][TracerData.TorghastDungeonIds[j]] = true;
			j = j - 1;
		end	
		while ( (j~=0) and (j~=12) and (j~=24) and (j~=36) and (j~=48) and (j~=60) and (j~=72)) do			
			TracerDB.Toons[TracerData.thisToon]["Torghast"][TracerData.TorghastDungeonIds[j]] = true;
			j = j - 1;
		end
	end
	
	--Affichage
	--TracerData.Function:WindowUpdateShadowlands();
end

function TracerData.Function:WorldBossCheckingSL()
	--WB SL	
	if TracerDB.Toons[TracerData.thisToon]["Level"] == 60 then	
		for key, value in pairs(WBSLInfo) do
			if	C_QuestLog.IsQuestFlaggedCompleted(key) then
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["WBSL"] = 1;						
				TracerDB.WBSL = value[1].." - "..value[2]; --Sauvegarde du nom du WeekBoss de la semaine	
				break;
			else
				TracerDB["Toons"][TracerData.thisToon]["Quests"]["SL"]["WBSL"] = 0;				
			end
		end
	else
		TracerDB["Toons"][TracerData.thisToon]["Quests"]["WBSL"] = -1;	
	end
	
	--Affichage
	--TracerData.Function:WindowUpdateShadowlands();
end

--Fonctions utilitaires
function TracerData.Function:AssaultMawResetChecking()
	if TracerDB["AssaultMawReset"] == 1 then return end

	local Date = date("*t");
	local count = 0;
	local resetWeekly = TracerDB["Reset"]["resetweekly"] - 302400;	--reset de l'asault 3.5j avant le reset weekly
	
	if time() > resetWeekly then
		TracerDB["AssaultMawReset"] = 1;	--On sauvegarde le reset
		for key, value in pairs(TracerDB.Toons) do
			value.Quests.SL.AssaultMaw = 0;
		end
	end	
	
	--Affichage
	--TracerData.Function:WindowUpdateShadowlands();
end

--TOOLTIP
function TracerData.Function:CallingsTooltip(toon)
	if (not TracerDB.Toons[toon]["Quests"]["SL"]["CallingsUnlocked"]) or (TracerDB.Toons[toon]["Level"] < 60) then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"];

	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], TracerData.L["Appels"], r, g, b);
	
	for index, value in ipairs(TracerDB.Toons[toon]["Quests"]["SL"]["Callings"]) do
		if value[2] then
			GameTooltip:AddDoubleLine(index.." "..TracerData.L["jours"], TracerData.L["Terminé"], 1, 1, 1, 0, 1, 0);
		else
			GameTooltip:AddDoubleLine(index.." "..TracerData.L["jours"], C_TaskQuest.GetQuestInfoByQuestID(value[1]), 1, 1, 1, 1, 0, 0);		
		end
	end
	
	GameTooltip:Show();	
end

function TracerData.Function:TorghastSoulAshLayerTooltip()
	local name = C_CurrencyInfo.GetCurrencyInfo(1828)["name"];
	local name2 = C_CurrencyInfo.GetCurrencyInfo(1906)["name"];
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPRIGHT", TracerData.Lines[9][3], "TOPLEFT");
	GameTooltip:AddDoubleLine("Torghast", name.." - "..name2, 1, 1, 1, 1 ,1, 1);	
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 1",  "180 (180)", 0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 2",  "150 (330)", 1, 1, 1, 1 ,1, 1);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 3",  "130 (460)", 0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 4",  "105 (565)", 1, 1, 1, 1 ,1, 1);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 5",  "90 (655)", 0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 6",  "75 (730)", 1, 1, 1, 1 ,1, 1);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 7",  "70 (800)",  0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 8",  "60 (860)", 1, 1, 1, 1 ,1, 1);	
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 9",  "55 (915) - 60 (60)", 0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);		
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 10", "45 (960) - 50 (110)", 1, 1, 1, 1 ,1, 1);		
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 11", "40 (1000) - 40 (150)", 0.65, 0.65, 0.65, 0.65 ,0.65, 0.65);		
	GameTooltip:AddDoubleLine(TracerData.L["Échelon"].." 12", "30 (1030) - 30 (180)", 1, 1, 1, 1 ,1, 1);	
	GameTooltip:Show();
end

function TracerData.Function:TorghastLockoutTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 60 then return end
	
	local _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, _, name, _ = GetLFGDungeonInfo(1963)	--id random juste pour le nom	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"];	
	local j = 0;
	local indexfloors = {1, 13, 25, 37, 49, 61, 73};
	local name2 = "";
	local flag = false
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], name, r, g, b);
	GameTooltip:AddLine(" ", 0, 1, 0);	
	
	--Lockouts Torghast	
	j = 0;
	for index, value in ipairs(TorghastWingsStart) do
		if TracerDB.Toons[toon]["Torghast"][value] then
			j = j + 1;
		end
	end
	GameTooltip:AddDoubleLine(TracerData.L["Ailes complétées"], j.."/2");
	for index, value in ipairs(indexfloors) do
		for k=value, value+11, 1 do
			if TracerDB.Toons[toon]["Torghast"][TracerData.TorghastDungeonIds[k]] then
				name2 = GetLFGDungeonInfo(TracerData.TorghastDungeonIds[k]);
				flag = true;
			end
		end
		if name2 ~= "" then
			GameTooltip:AddLine(name2, 0, 1, 0);
			name2 = "";
		end
	end
	if not flag then
		GameTooltip:AddLine("No Lockouts", 1, 0, 0);
	end
	
	GameTooltip:Show();
end

function TracerData.Function:WeeklyDungeonQuestsTooltip(toon)
	if not TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuestsUnlocked"] then return end
	
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"];
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], TracerData.L["Quêtes de donjon de la semaine"], r, g, b);
	
	if TracerDB.WeeklyDungeonQuestsIdsSL[1] ~= 0 then
		if TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] == -1 then
			GameTooltip:AddLine("Go pick the quests", 1, 0, 0);
		elseif TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] == 0 then
			GameTooltip:AddLine(TracerDB.WeeklyDungeonQuestsIdsSL[2], 1, 0, 0);
		elseif TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][1] == 1 then
			GameTooltip:AddLine(TracerDB.WeeklyDungeonQuestsIdsSL[2], 0, 1, 0);		
		end	
	end
	if TracerDB.WeeklyDungeonQuestsIdsSL[3] ~= 0 then
		if TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] == -1 then
			GameTooltip:AddLine("Go pick the quests", 1, 0, 0);
		elseif TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] == 0 then
			GameTooltip:AddLine(TracerDB.WeeklyDungeonQuestsIdsSL[4], 1, 0, 0);
		elseif TracerDB.Toons[toon]["Quests"]["SL"]["WeeklyDungeonQuests"][2] == 1 then
			GameTooltip:AddLine(TracerDB.WeeklyDungeonQuestsIdsSL[4], 0, 1, 0);		
		end	
	end
	
	GameTooltip:Show();
end

function TracerData.Function:SLQuestsTooltip(toon)
	if TracerDB.Toons[toon]["Level"] < 60 then return end	
		
	local r, g, b = TracerDB.Toons[toon]["ClassColor"]["r"], TracerDB.Toons[toon]["ClassColor"]["g"], TracerDB.Toons[toon]["ClassColor"]["b"];
	
	GameTooltip:Hide();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR");
	GameTooltip:AddDoubleLine(TracerDB.Toons[toon]["Name"], TracerData.L["Quêtes SL"], r, g, b);
	
	if TracerDB.Toons[toon]["Quests"]["SL"]["Quests"][2] == 1 then
		GameTooltip:AddLine(C_QuestLog.GetTitleForQuestID(61981), 0, 1, 0);	
	else
		GameTooltip:AddLine(C_QuestLog.GetTitleForQuestID(61981), 1, 0, 0);	
	end	
	
	GameTooltip:Show();
end